﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;

namespace InfragisticsBug
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Collection<string> m_FieldNames = new Collection<string>();

        public ObservableCollection<UselessObject> UselessObjects
        {
            get { return (ObservableCollection<UselessObject>)GetValue(UselessObjectsProperty); }
            set { SetValue(UselessObjectsProperty, value); }
        }

        // Using a DependencyProperty as the backing store for UselessObjects.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty UselessObjectsProperty =
            DependencyProperty.Register("UselessObjects", typeof(ObservableCollection<UselessObject>), typeof(MainWindow), new UIPropertyMetadata(null));

        public MainWindow()
        {
            InitializeComponent();

            DataContext = this;

            m_FieldNames.Add("IsUseful");
            m_FieldNames.Add("Name");

            UselessObjects = new ObservableCollection<UselessObject>();

            for(int i = 0; i < 10; i++)
            {
                UselessObject obj = new UselessObject("Test" + i);

                UselessObjects.Add(obj);
            }

            foreach (string name in m_FieldNames)
            {
                UnboundField field = new UnboundField();
                field.Name = name;
                field.BindingPath = new PropertyPath(name);

                defaultLayout.Fields.Add(field);
            }
        }

        private void btnRemove_Click(object sender, RoutedEventArgs e)
        {
            foreach (string name in m_FieldNames)
            {
                defaultLayout.Fields.Remove(defaultLayout.Fields[name]);
            }

            defaultLayout.RecordFilters.Clear();
        }
    }

    public class UselessObject
    {
        public bool IsUseful
        {
            get { return false; }
        }

        public string Name
        {
            get;
            private set;
        }

        public UselessObject(string name)
        {
            Name = name;
        }
    }
}
